
#property copyright "Copyright  2009, primajaya"
#property link      "http://www.forex-tsd.com/suggestions-trading-systems/19386-daily-breakout-ea.html"

//---- input parameters
extern int       TP           = 20;//
extern int       TP_Increment   = 20;//
extern int       SL           = 80;
extern int       RangePoint   = 10;
extern int       AddPoint     = 10;// add point to place stop order  [high+AddPoint] and [low-AddPoint]
extern double    LotSize      = 1.0;
extern int       LotDevider   = 5;// LotSize must be dividable by this number; number must be 1 or higher. Also Broker must support the resulting Lotsize
extern int       MagicNumber  = 123456789;
extern bool      DelOpposite = false;
extern bool      MoveToBEP = true; 
extern int       LockProfit = 1;
extern int       TrailingStop = 40;// if 0, no Trailing Stop


static double LotPart;
static int  nextTP;
int  realTP;
int  TP1;


#define slip 2
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

TP1 = TP;
if(LotDevider<1) LotDevider =1;
realTP = TP_Increment*(LotDevider-1) + TP;
LotPart = LotSize/LotDevider;

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double stoplevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*point();
   double tik = iVolume(NULL,0,0);
   int exp = TimeCurrent() + (Period()*59);
   double buyPrice, sellPrice;
   
   RefreshRates();
   if(High[1]-Ask < stoplevel) buyPrice = Ask + RangePoint*point();
   else buyPrice = High[1] + AddPoint*point();
   
   if(Bid-Low[1] < stoplevel) sellPrice = Bid - RangePoint*point();
   else sellPrice = Low[1] - AddPoint*point();
   
   
   if(OrdersTotal() == 0)
   {
      nextTP = TP;
      if(tik <= 3)
      {
         openOrder(Symbol(), OP_BUYSTOP,LotSize,buyPrice,buyPrice-SL*point(), buyPrice+realTP*point(),"_Buy_",MagicNumber,exp,Navy);
         openOrder(Symbol(), OP_SELLSTOP,LotSize,sellPrice,sellPrice+SL*point(), sellPrice-realTP*point(),"_Sell_",MagicNumber,exp,Crimson);   
      }   
   }
   
   if(OrdersTotal()==1)
   {
      if(!DelOpposite) nextTP = TP;
   }
   
   if(OrdersTotal() == 2)
   {
      for (int i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol())
         {
            if(OrderMagicNumber()==MagicNumber)
            {
               if(DelOpposite)
               {
                  if(OrderType()==OP_BUY) delPending(OP_SELLSTOP,MagicNumber);
                  if(OrderType()==OP_SELL) delPending(OP_BUYSTOP,MagicNumber);
               }
            }
         
         }
      }
   
   }
   
   if(OrdersTotal() > 0)
   {
      if(LotDevider>1) manageTP();
      if(MoveToBEP) BEP();
      if(TrailingStop>0) TS();
   }   
//----
   return(0);
  }
//+------------------------------------------------------------------+

void openOrder(string simbol, int trade, double lotsize, double price, double sl, double tp,string pesan, int magic, int exp, color warna) 
{                     
  int tiket=OrderSend(simbol,trade,lotsize,price,slip,sl,tp,pesan,magic,exp,warna);                              
      if(tiket>0)
      {  
         if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES)) OrderPrint(); 
      }
         else Print("Cannot send order because of : ",GetLastError());        
}

void delPending(int trade, int MagicNumber)
{  
    for(int i=0;i<OrdersTotal();i++)
    {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if(OrderType()==trade)
       { 
         if(OrderMagicNumber()==MagicNumber) OrderDelete(OrderTicket(),CLR_NONE);
       }  
    }   
}

double point()
{
   double p;
   if(Digits==5 || Digits==3) p = Point*10;
   else p = Point;
   
   return(p);
}

void BEP()
{
      for (int i = 0; i < OrdersTotal(); i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
            if(OrderType()==OP_BUY)
            {
               if(Bid-OrderOpenPrice() >= point()*TP1)
               {
                  if(OrderStopLoss()<OrderOpenPrice())
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+point()*LockProfit,OrderTakeProfit(),0,CLR_NONE);
                     return(0);
                  }
               }
            }
         
            if(OrderType()==OP_SELL)
            {
               if(OrderOpenPrice()-Ask >= point()*TP1)
               {
                  if(OrderStopLoss()>OrderOpenPrice())
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-point()*LockProfit,OrderTakeProfit(),0,CLR_NONE);
                     return(0);
                  }
               }      
            }
         } 
      }   
}

void TS()
{
 for (int i = 0; i < OrdersTotal(); i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
            if(OrderType()==OP_BUY)
            {
               if(Bid-OrderOpenPrice()>point()*TrailingStop)
               {
                  if(OrderStopLoss()<Bid-point()*TrailingStop || (OrderStopLoss()==0))
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-point()*TrailingStop,OrderTakeProfit(),0,CLR_NONE);
                     return(0);
                  }
               }
            }
         
            if(OrderType()==OP_SELL)
            {
               if((OrderOpenPrice()-Ask)>(point()*TrailingStop))
               {
                  if((OrderStopLoss()>(Ask+point()*TrailingStop)) || (OrderStopLoss()==0))
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+point()*TrailingStop,OrderTakeProfit(),0,CLR_NONE);
                     return(0);
                  }
               }      
            }
         } 
      
      }   
}

void manageTP()
{
      for (int i = 0; i < OrdersTotal(); i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
            if(OrderType()==OP_BUY)
            {
               if(Bid-OrderOpenPrice() >= point()*nextTP)
               {
                  OrderClose(OrderTicket(),LotPart,Bid,slip,Blue);   
                  nextTP += TP_Increment;
                  return(0);
               }
            }
         
            if(OrderType()==OP_SELL)
            {
               if(OrderOpenPrice()-Ask > point()*nextTP)
               {
                  OrderClose(OrderTicket(),LotPart,Ask,slip,Blue);   
                  nextTP += TP_Increment;
                  return(0);
               }      
            }
         } 
      }   
}